package TJournal::PFAnalysis::AvgGain;

# PFAnalysis.pm -- author: Oliver Bossert
# Copyright (C) 2004 Oliver Bossert
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

use strict;

use TJournal::Conf;
use TJournal::DB;

use TJournal::PFAnalysis;
our @ISA = qw(TJournal::PFAnalysis);

use TJournal::PFAnalysis::CumGain;
use TJournal::PFAnalysis::NbGains;

############################################################
sub calc {
############################################################
  my $self = shift;
  my $o1 = TJournal::PFAnalysis::CumGain->new( $self->{'data'} );
  my $o2 = TJournal::PFAnalysis::NbGains->new( $self->{'data'} );
  my $cum = $o1->calc() / 100;
  my $nb = $o2->calc();
  my $ret =  $cum ** (1 / $nb) - 1 if ($nb != 0);
  return $ret*100;
}

############################################################
sub formated {
############################################################
  my $self = shift;
  my $res = $self->calc();
  $res =  sprintf("%.2f",$res);
  return $res . "%";
}

############################################################
sub color {
############################################################
  my $self = shift;

  my $cal = $self->calc();
  TJournal::Conf::default("PFAnalysis::AvgGain::Coloring", 
			  "verybad:0~0.5;bad:0.5~1;neutral:1~5;good:5~10;verygood:10~99999");
  my $line = TJournal::Conf::get("PFAnalysis::AvgGain::Coloring");
  my $col = 'neutral';
  foreach my $val ( split /;/, $line ) {
    if ( $val =~ /(\w+):([\d\.-]+)~([\d\.-]+)/ ) {
      if ( $cal >= $2 && $cal < $3 ) {
	$col = $1;
      }
    }
  }
  return $col;
}

############################################################
sub name {
############################################################
  my $self = shift;
  return "The (geom.) average gain";
}

############################################################
sub info {
############################################################
  my $self = shift;
  return "Your average gain of the trades you've won.\n";
}


1;
