package TJournal::Translate;

# Translate.pm -- author: Oliver Bossert
# Copyright (C) 2004 Oliver Bossert
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

use strict;

use TJournal::Conf;

our %trans;
our $done;

require Exporter;
our @ISA = qw(Exporter);
our @EXPORT = qw(_t);


# Load language
if ( !defined($done) || $done == 0 ) {
  $done = 1;
  my $file = TJournal::Conf::get("LANG");
  if ( defined($file) ) {
    open F, $file or warn "Language file: $file not found!";
    while (<F>) {
      chomp;
      my ($t1, $t2) = split /\t/, $_;
#      print ">$t1<  >$t2<\n";
      $trans{$t1} = $t2;
    }
    close F;
  }
}

sub _t {
  my $text = shift;
  my $t2 = $text;
  $t2 =~ s/\n/<BR>/mg;
#  print ">" . $t2 . "<\n";
  if ( defined($trans{$t2}) &&
       $trans{$t2} ne "" ) {
#    print ">>>" . $trans{$t2} . "\n";
    $t2 = $trans{$t2};
    $t2 =~ s/\<BR\>/\n/mg;
    $t2 =~ s/^\s*//;
    return $t2;
  }
  return $text;
}

1;
